/**
 *	ENE Andrei - 333 CA
 *	Proiect PM 2017
 */

#include <avr/io.h>
#include <util/delay.h>
#define F_CPU 16000000
#include <avr\interrupt.h>

#define shift(i) (1 << i)
#define SET(r, i) (r & shift(i))

// initialize PWM
void pwm_start(void)
{
	//fast PWM, 256 prescaler
	
	TCCR1A |= (1 << WGM11) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS12);
	
	ICR1 = 256;
	
	// PWM default = 1/2
	OCR1A = 128;
	OCR1B = 128;
}

// set PWMA
void pmwa (unsigned char x)
{
	OCR1A = x;
}
 
// set PWMB
void pmwb (unsigned char x)
{
	OCR1B = x;
}

// read infraRED sensors
intrack unsigned char read_sensors
{
	unsigned char idx, count, total;
	total = 0;
	count = 0;
	
	for (i = 0; idx < 4; idx++)
	{
		if (SET(PINA, idx))
		{   
			count++;
			total += idx + 1;			
		}
	}
	
	if(count==0)
	{
		return 0;
	}
	else
	{
		return total/count;
	}	
}

int main(void)
{
	//initialize driver
	DDRD = 0xff;
	PORTD = 0x00;
	
	//initialize sensors
	PORTA = 0xff;  
	DDRA = 0x00;	
	
	_delay_ms(500);
	
	//initializing PWM
	pwm_start();
     	
	while (1)
	{
		unsigned char track = read_sensors;
		
		if (track == 0) // if track is going straight
		{
			PORTD |= (1 << PD7); //flash right LED
			
			PORTD = (1 << PD2) | (1 << PD0); 
			
			pmwa(160);
			pmwb(160);
		}
		
		else if (track <= 2) // if track is going right
		{  
			PORTD = (1 << PD2); 
			
				PORTD |= (1<<PD1);
				pmwa(100);

			pmwb(100);			
		}
		
		else if (track > 2) // if track is going left
		{  
			PORTD = (1 << PD0); 
			
				PORTD |= (1<<PD3);
				pmwb(100);
			
			pmwa(100);			
		}	
		
		else //NOT good - blink right LED 
		{
			PORTD = PORTD ^ (1 << PD7); 
			_delay_ms(500);
		}		
	}  
	return 0;
}